{
Author:  Prof1983: <prof1983@yandex.ru>
Created: 28.05.2011
LastMod: 29.05.2011
}
unit TestProcShort;

interface

uses
  Windows,
  TestCallData, TestUnit1;

function TestProcShortCdecl: Integer;
function TestProcShortCdeclTimer: Integer;
function TestProcShortFastcall: Integer;
function TestProcShortFastcallTimer: Integer;
function TestProcShortSafecall: Integer;
function TestProcShortSafecallTimer: Integer;
function TestProcShortStdcall: Integer;
function TestProcShortStdcallTimer: Integer;

implementation

function TestProcShortCdecl: Integer;
var
  I: Integer;
  T1: DWORD;
  T2: DWORD;
begin
  ProcCdecl(1, 2);
  T1 := GetTickCount();
  for I := 0 to COUNT_I do
    ProcCdecl(1, 2);
  T2 := GetTickCount();
  Result := T2 - T1;
end;

function TestProcShortCdeclTimer: Integer;
begin
  ProcCdecl(1, 2);
  Result := 0;
  FStopping := False;
  while not(FStopping) do
  begin
    ProcCdecl(1, 2);
    Inc(Result);
  end;
end;

function TestProcShortFastcall: Integer;
var
  I: Integer;
  T1: DWORD;
  T2: DWORD;
begin
  ProcFastcall(1, 2);
  T1 := GetTickCount();
  for I := 0 to COUNT_I do
    ProcFastcall(1, 2);
  T2 := GetTickCount();
  Result := T2 - T1;
end;

function TestProcShortFastcallTimer: Integer;
begin
  ProcFastcall(1, 2);
  Result := 0;
  FStopping := False;
  while not(FStopping) do
  begin
    ProcFastcall(1, 2);
    Inc(Result);
  end;
end;

function TestProcShortSafecall: Integer;
var
  I: Integer;
  T1: DWORD;
  T2: DWORD;
begin
  ProcSafecall(1, 2);
  T1 := GetTickCount();
  for I := 0 to COUNT_I do
    ProcSafecall(1, 2);
  T2 := GetTickCount();
  Result := T2 - T1;
end;

function TestProcShortSafecallTimer: Integer;
begin
  ProcSafecall(1, 2);
  Result := 0;
  FStopping := False;
  while not(FStopping) do
  begin
    ProcSafecall(1, 2);
    Inc(Result);
  end;
end;

function TestProcShortStdcall: Integer;
var
  I: Integer;
  T1: DWORD;
  T2: DWORD;
begin
  ProcStdcall(1, 2);
  T1 := GetTickCount();
  for I := 0 to COUNT_I do
    ProcStdcall(1, 2);
  T2 := GetTickCount();
  Result := T2 - T1;
end;

function TestProcShortStdcallTimer: Integer;
begin
  ProcStdcall(1, 2);
  Result := 0;
  FStopping := False;
  while not(FStopping) do
  begin
    ProcStdcall(1, 2);
    Inc(Result);
  end;
end;

end.
 