{
Author:  Prof1983: <prof1983@yandex.ru>
Created: 27.05.2011
LastMod: 29.05.2011
}
unit TestUnit1;

interface

function ProcCdecl(Param1, Param2: Integer): Integer; cdecl;
function ProcFastcall(Param1, Param2: Integer): Integer;
function ProcSafecall(Param1, Param2: Integer): Integer; safecall;
function ProcStdcall(Param1, Param2: Integer): Integer; stdcall;

implementation

function ProcCdecl(Param1, Param2: Integer): Integer; cdecl;
begin
  Result := Round((Param1 + Param2) / (Param1 * Param2)) * Round((Param1 + Param2) / (Param1 * Param2));
end;

function ProcFastcall(Param1, Param2: Integer): Integer; register;
begin
  Result := Round((Param1 + Param2) / (Param1 * Param2)) * Round((Param1 + Param2) / (Param1 * Param2));
end;

function ProcSafecall(Param1, Param2: Integer): Integer; safecall;
begin
  Result := Round((Param1 + Param2) / (Param1 * Param2)) * Round((Param1 + Param2) / (Param1 * Param2));
end;

function ProcStdcall(Param1, Param2: Integer): Integer; stdcall;
begin
  Result := Round((Param1 + Param2) / (Param1 * Param2)) * Round((Param1 + Param2) / (Param1 * Param2));
end;

end.
 